package cn.gyee.nxdp;

import cn.gyee.nxdp.entities.auto.WindTurbineTestingPointAi2;
import cn.gyee.nxdp.entities.auto.Windturbine;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @ClassName CacheContext
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/9/18 9:41
 * @Version 1.0
 **/
@Component
public class CacheContext implements CommandLineRunner {
    @Autowired
    private JdbcTemplate jdbcTemplate;

    public static List<Windturbine> wtls = new ArrayList<>();
    public static Map<String, Map<String,WindTurbineTestingPointAi2>> wtmap = new HashMap<>();

    @Override
    public void run(String... args) throws Exception {
        System.out.println(">>>>>>>>>>>>>>>服务启动执行，执行加载数据操作<<<<<<<<<<<<<");
        String sql = "select * from windturbine";
        List<Windturbine> windturbines = jdbcTemplate.query(sql, new RowMapper<Windturbine>() {
            @Override
            public Windturbine mapRow(ResultSet rs, int i) throws SQLException {
                Windturbine wt = new Windturbine();
                wt.setId(rs.getString("id"));
                wt.setCode(rs.getString("code"));
                wt.setWindpowerstationid(rs.getString("windpowerstationid"));
                wt.setLatitude(rs.getBigDecimal("longitude"));
                wt.setLatitude(rs.getBigDecimal("latitude"));
                wt.setModelid(rs.getString("modelid"));
                wt.setStatus(rs.getString("status"));
                wt.setProjectid(rs.getString("projectid"));
                wt.setLineid(rs.getString("lineid"));
                wt.setFirstintegratedtime(rs.getDate("firstintegratedtime"));
                wt.setPhoto(rs.getString("photo"));
                wt.setName(rs.getString("name"));
                wt.setStandardid(rs.getString("standardid"));
                return wt;
            }
        });
        wtls = windturbines.stream().filter(wt -> wt.getWindpowerstationid().endsWith("FDC")).collect(Collectors.toList());
        for(Windturbine wt :wtls){
            Map<String,WindTurbineTestingPointAi2> ai2Map = new HashMap<>();
            String wtaisql = "select * from WindTurbineTestingPointAi2 where windturbineid=?";
            List<WindTurbineTestingPointAi2> wtais = jdbcTemplate.query(wtaisql, new RowMapper<WindTurbineTestingPointAi2>() {
                @Override
                public WindTurbineTestingPointAi2 mapRow(ResultSet rs, int i) throws SQLException {
                    WindTurbineTestingPointAi2 ai2 = new WindTurbineTestingPointAi2();
                    ai2.setId(rs.getString("id"));
                    ai2.setCode(rs.getString("code"));
                    ai2.setName(rs.getString("name"));
                    ai2.setModel(rs.getString("model"));
                    ai2.setValueunit(rs.getString("valueunit"));
                    ai2.setEnglishname(rs.getString("englishname"));
                    ai2.setTypeid(rs.getString("typeid"));
                    ai2.setModelid(rs.getString("modelid"));
                    ai2.setMaxval(rs.getBigDecimal("maxval"));
                    ai2.setMinval(rs.getBigDecimal("minval"));
                    ai2.setReasonablemaxval(rs.getBigDecimal("reasonablemaxval"));
                    ai2.setReasonableminval(rs.getBigDecimal("reasonableminval"));
                    ai2.setWindturbineid(rs.getString("windturbineid"));
                    ai2.setUniformcode(rs.getString("uniformcode"));
                    ai2.setShortid(rs.getString("shortid"));
                    ai2.setLongid(rs.getString("longid"));
                    ai2.setWindpowerstationid(rs.getString("windpowerstationid"));
                    ai2.setRealtimeid(rs.getString("realtimeid"));
                    return ai2;
                }
            },wt.getId());
            for(WindTurbineTestingPointAi2 wtai :wtais){
                ai2Map.put(wtai.getUniformcode(),wtai);
            }
            wtmap.put(wt.getId(),ai2Map);
        }


        System.out.println(">>>>>>>>>>>>>>>服务启动完成，执行加载数据完成<<<<<<<<<<<<<");


    }
}
