package cn.gyee.nxdp.colltroller;

import cn.gyee.nxdp.entities.vo.PersonLnglat;
import cn.gyee.nxdp.entities.vo.Shbracelet;
import cn.gyee.nxdp.entities.vo.ShbraceletVo;
import cn.gyee.nxdp.services.shbracelet.ShbraceletService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * @ClassName BraceletColltroller
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/9/15 10:48
 * @Version 1.0
 **/
@Controller
@RequestMapping("/bracelet")
public class BraceletColltroller {

    @Autowired
    private ShbraceletService shbraceletService;

    @RequestMapping("getInfo")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public List<ShbraceletVo> getInfo(@RequestParam(value = "beginDate", required = false) String beginDate,
                                      @RequestParam(value = "endDate", required = false) String endDate,
                                      @RequestParam(value = "userid") String userid) throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if (beginDate == null) {
            beginDate = sdf.format(dateRoll(new Date(), Calendar.HOUR, -4));
        }
        if (endDate == null) {

            endDate = sdf.format(new Date());
        }
        List<ShbraceletVo> vo = shbraceletService.findShbraceletData(userid,
                sdf.parse(beginDate), sdf.parse(endDate));

        return vo;
    }


    @RequestMapping("getLnglat")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public List<PersonLnglat> getLnglat() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        List<PersonLnglat> vo = shbraceletService.findPersonLnglatData();

        return vo;
    }

    @RequestMapping("getLnglatnew")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public List<Shbracelet> getLnglatnew() throws Exception {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        List<Shbracelet> vo = shbraceletService.findShbraceletDataNew();

        return vo;
    }

    public static Date dateRoll(Date date, int i, int d) {
        // 获取Calendar对象并以传进来的时间为准
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        // 将现在的时间滚动固定时长,转换为Date类型赋值
        calendar.add(i, d);
        // 转换为Date类型再赋值
        date = calendar.getTime();
        return date;
    }
}
