package cn.gyee.nxdp.colltroller;

import cn.gyee.nxdp.model.auto.Earlywarningknowledgemain;
import cn.gyee.nxdp.model.auto.Earlywarningknowledgesub;
import cn.gyee.nxdp.model.auto.Windturbine;
import cn.gyee.nxdp.service.IWindturbineService;
import cn.gyee.nxdp.services.early.EarlyWarningService;
import cn.gyee.nxdp.util.JsonUtils;
import com.alibaba.fastjson.JSON;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *@ClassName EarlyWarningController
 *@Description TODO
 *@Author 谢生杰
 *@Date 2021/1/11 15:11
 *@Version 1.0
 **/
@Controller
@RequestMapping("/earlyWarning")
public class EarlyWarningController {

    @Autowired
    private IWindturbineService windturbineService;
    @Autowired
    private EarlyWarningService earlyWarningService;

    /**
     * 根据风场查询型号
     */
    @GetMapping("/modelListByWp")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public List<String> modelListByWp(@RequestParam(value = "stationid", required = false)String wpid){
        return windturbineService.modelListByWpId(wpid);
    }


    /**
     * 根据风场，型号，开始结束日期，规则条件查询
     * @return
     */
    @GetMapping("/wtsEarlyCount")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public String wtsEarlyCount(@RequestParam(value = "beginDate", required = false)String beginDate,
                                @RequestParam(value = "endDate", required = false)String endDate,
                                @RequestParam(value = "stationid", required = false)String wpid,
                                @RequestParam(value = "modelid", required = false)String modelid,
                                @RequestParam(value = "checkboxGroupList", required = false)String  checkboxGroupList){
        List<Earlywarningknowledgesub> list =JSON.parseArray(checkboxGroupList,Earlywarningknowledgesub.class);
        Map<String, Map<String,Integer>> wtEarlyCountMap = earlyWarningService.findWtEarlyCount(beginDate, endDate,wpid,modelid,list);

        return JsonUtils.toJson(wtEarlyCountMap);

    }

    /**
     * 保存模型
     * @return
     */
    @GetMapping("/saveEarlyWarning")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public void saveEarlyWarning( @RequestParam(value = "stationid", required = false)String wpid,
                                    @RequestParam(value = "modelid", required = false)String modelid,
                                    @RequestParam(value = "checkboxGroupList", required = false) String checkboxGroupList) {
        List<Earlywarningknowledgesub> list =JSON.parseArray(checkboxGroupList,Earlywarningknowledgesub.class);
        earlyWarningService.saveEarlyWarning(wpid,modelid,list);
    }

    /**
     * 记录查询
     * @return
     */
    @GetMapping("/mainList")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public String mainList( @RequestParam(value = "stationid", required = true)String wpid,
                            @RequestParam(value = "modelid", required = true)String modelid) {
        List<Earlywarningknowledgemain> list =  earlyWarningService.findDataByWpAndModel(wpid,modelid);
        return JsonUtils.toJson(list);

    }


    /**
     * 根据记录查询规则列表
     * @return
     */
    @GetMapping("/sublist")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public String sublist( @RequestParam(value = "tid", required = true)Integer tid){
        List<Earlywarningknowledgesub> list = earlyWarningService.findSubListByMain(tid);
        return JsonUtils.toJson(list);
    }

    /**
     * 生成缺陷单
     * @return
     */
    @GetMapping("/createWobugeq")
    @ResponseBody
    @CrossOrigin(origins = "*", maxAge = 3600)
    public void createWobugeq( @RequestParam(value = "description", required = false) String description,
                                 @RequestParam(value = "wts", required = true) String wts){
        Map<String,String[]> mismap = earlyWarningService.getMismap();
        String[] wtls = wts.split(",");
        Map<String,Windturbine> sismap = new HashMap<>();
        List<Windturbine> wtl = windturbineService.findAll();
        for (Windturbine windturbine : wtl) {
            sismap.put(windturbine.getId(),windturbine);
        }
        Arrays.stream(wtls).forEach(wt -> earlyWarningService.createWobugeq(wt,description,sismap,mismap));

    }

}
