package cn.gyee.nxdp.entities.nxdp;

import lombok.Data;

import java.io.Serializable;

/**
 *@ClassName Company
 *@Description 公司指标表
 *@Author 谢生杰
 *@Date 2020/8/28 10:40
 *@Version 1.0
 **/
@Data
public class CompanyTarget implements Serializable{

    private static final long serialVersionUID = 2821855825709469235L;


    private String tq;//天气
    private Double wd;//温度
    private Double xdsd;//相对湿度
    private String fl;//风力
    private Double kqmd;//空气密度
    private Double zjrl;//装机容量
    private Double aqts;//安全天数
    private Double jpeyht;//减排二氧化碳
    private Double jpeyhl;//减排二氧化硫
    private Double jyys;//节约用书
    private Double jybm;//节约标煤
    private Double fdcjr;//风电场接入
    private Double fdcbw;//风电场并网
    private Double fdcdj;//风电场待机
    private Double fdcjx;//风电场检修
    private Double fdcgz;//风电场故障
    private Double fdcxd;//风电场限电
    private Double fdcsl;//风电场受累
    private Double fdclx;//风电场离线
    private Double gdcjr;//光伏接入
    private Double gdcbw;//光伏并网
    private Double gdcdj;//光伏待机
    private Double gdcjx;//光伏检修
    private Double gdcgz;//光伏故障
    private Double gdcxd;//光伏限电
    private Double gdcsl;//光伏受累
    private Double gdclx;//光伏离线
    private Double dqfh;//当前负荷
    private Double rzgfh;//日最高负荷
    private Double yzgfh;//月最高负荷
    private Double ycgl;//预测功率
    private Double bzgl;//保证功率
    private Double llgl;//理论功率
    private Double rwcl;//日完成率
    private Double ywcl;//月完成率
    private Double nwcl;//年完成率
    private Double swdl;//上网电量
    private Double gwdl;//购网电量
    private Double mtbf;//月mtbf
    private Double mttr;//月mttr
    private Double zhcydl;//月综合厂用电率
    private Double sbklyl;//月设备可利用率
    private Double fnlyl;//月风能利用率
    private Double mhsfdl;//麻黄山发电量
    private Double mhsfs;//麻黄山风速
    private Double mhsllgl;//麻黄山理论功率
    private Double mhscxgl;//麻黄山出线功率
    private Double mhsagc;//麻黄山agc
    private Double nssfdl;//牛首山发电量
    private Double nssfs;//牛首山风速
    private Double nssllgl;//牛首山理论功率
    private Double nsscxgl;//牛首山出线功率
    private Double nssagc;//牛首山agc
    private Double qsfdl;//青山发电量
    private Double qsfs;//青山风速
    private Double qsllgl;//青山理论功率
    private Double qscxgl;//青山出线功率
    private Double qsagc;//青山agc
    private Double sbqfdl;//石板泉发电量
    private Double sbqfs;//石板泉风速
    private Double sbqllgl;//石板泉理论功率
    private Double sbqcxgl;//石板泉出线功率
    private Double sbqagc;//石板泉agc
    private Double xsfdl;//香山发电量
    private Double xsfs;//香山风速
    private Double xsllgl;//香山理论功率
    private Double xscxgl;//香山出线功率
    private Double xsagc;//香山agc
    private Double plfdl;//平罗发电量
    private Double plfs;//平罗风速
    private Double plllgl;//平罗理论功率
    private Double plcxgl;//平罗出线功率
    private Double plagc;//平罗agc
    private Double dwkfdl;//大武口发电量
    private Double dwkfs;//大武口风速
    private Double dwkllgl;//大武口理论功率
    private Double dwkcxgl;//大武口出线功率
    private Double dwkagc;//大武口agc
    private Double xhfdl;//宣和发电量
    private Double xhfs;//宣和风速
    private Double xhllgl;//宣和理论功率
    private Double xhcxgl;//宣和出线功率
    private Double xhagc;//宣和agc
}
