package cn.gyee.nxdp.service.impl;

import cn.gyee.nxdp.service.WinturbinDataService;
import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;
import org.springframework.web.client.HttpClientErrorException;
import org.springframework.web.client.RestTemplate;

import javax.jws.WebMethod;
import javax.jws.WebService;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @descrition:
 * @author:MXX
 * @date:2020-10-18
 */
@Service
public class WinturbinDataServiceImpl implements WinturbinDataService
{
    private RestTemplate restTemplate = new RestTemplate();
    private String baseURL = "http://192.168.1.14:8075/alarm" ;

    public String getAlarmByWindturbinData(Date starttime, Date endtime, String windturbineid)
    {
        String stationid="";

        SimpleDateFormat fmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String url = baseURL + "/history/page?category1=windturbine";
        if (starttime != null)
            url = url + "&starttime=" + fmt.format(starttime);
            url = url + "&pagenum=1";
            url = url + "&pagesize=10000000";
        if (endtime != null)
            url = url + "&endtime=" + fmt.format(endtime);
            url = url +"&windturbineid=" +windturbineid;
        switch (windturbineid.substring(0,2)){
            case "XG":stationid ="XS_FDC";
                break;
            case "MG":stationid ="MHS_FDC";
                break;
            case "QG":stationid ="QS_FDC";
                break;
            case "NG":stationid ="NSS_FDC";
                break;
            default:stationid ="SBQ_FDC";
                break;
        }
        url = url + "&stationid="+stationid ;

        System.out.println(url);

        try
        {
            ResponseEntity<JSONObject> resp = restTemplate.getForEntity(url, JSONObject.class);

            JSONObject jsonArray = resp.getBody();

            return jsonArray.toString();

        }
        catch (HttpClientErrorException exception)
        {
            if (exception.getStatusCode() == HttpStatus.NOT_FOUND)
            {
                System.out.println("404请求错误");
                return null;
            }
            else
            {
                throw exception;
            }
        }
    }
}
