package cn.gyee.nxdp.services;

import cn.gyee.nxdp.CacheContext;
import cn.gyee.nxdp.Contant;
import cn.gyee.nxdp.entities.auto.Windturbine;
import cn.gyee.nxdp.entities.custom.PointData;
import cn.gyee.nxdp.entities.nxdp.CompanyTarget;
import cn.gyee.nxdp.entities.vo.DataVo;
import cn.gyee.nxdp.util.ObjUtil;
import cn.gyee.nxdp.util.redis.RedisService;
import cn.gyee.nxdp.util.common.StringUtils;
import cn.gyee.nxdp.util.golden.EdosUtil;
import cn.gyee.nxdp.util.golden.IEdosUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

/**
 * /**
 *
 * @ClassName CompanyTarget
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/8/28 8:55
 * @Version 1.0
 **/
@Service
public class CompanyTargetService {
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private RedisService redisService;

    public void companyToRedis() {
        IEdosUtil edosUtil = new EdosUtil();
        CompanyTarget company = new CompanyTarget();
        StringBuilder sb = new StringBuilder();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.MILLISECOND, 0);
        calendar.set(Calendar.SECOND, 0);
        calendar.set(Calendar.MINUTE, 0);
        calendar.set(Calendar.HOUR_OF_DAY, 0);

        String formatDate = sdf.format(calendar.getTime());
        String sql = "select maximumtem,minimumtem,weather from weatherfd where windpowerstationid='MHS_FDC' and to_char(recodedata,'yyyy-MM-dd')=?";
        List<DataVo> tqlist = jdbcTemplate.query(sql, new RowMapper<DataVo>() {
            @Override
            public DataVo mapRow(ResultSet rs, int i) throws SQLException {
                DataVo vo = new DataVo();
                String tq = rs.getString("weather");
                Double maximumtem = rs.getDouble("maximumtem");
                Double minimumtem = rs.getDouble("minimumtem");
                Double wd = (maximumtem + minimumtem) / 2;
                vo.setSvalue1(tq);
                vo.setDvalue1(wd);
                return vo;
            }
        }, formatDate);
        if (tqlist != null && tqlist.size() > 0) {
            DataVo vo = tqlist.get(0);
            company.setTq(vo.getSvalue1() == null ? "" : vo.getSvalue1());//天气
            company.setWd(vo.getDvalue1() == null ? 0 : vo.getDvalue1());//温度
            company.setKqmd(101325 / (287.05 * (vo.getDvalue1() + 273.15)));//空气密度(kg/m3)
        }

        String rlsql = "select capacity from windpowerstation";
        List<Double> rllist = jdbcTemplate.query(rlsql, new RowMapper<Double>() {

            @Override
            public Double mapRow(ResultSet rs, int i) throws SQLException {
                return rs.getDouble("capacity");
            }
        });
        Double zjrl = rllist.stream().reduce(Double::sum).get();
        company.setZjrl(zjrl == null ? 0 : zjrl);//装机容量
        double aqts = 0d;
        double jpeyht = 0d;
        double jpeyhl = 0d;
        double jyys = 0d;
        double jybm = 0d;
        double fdcjr = 0d;
        double fdcbw = 0d;
        double fdcdj = 0d;
        double fdcjx = 0d;
        double fdcgz = 0d;
        double fdcxd = 0d;
        double fdcsl = 0d;
        double fdclx = 0d;
        double gdcjr = 0d;
        double gdcbw = 0d;
        double gdcdj = 0d;
        double gdcjx = 0d;
        double gdcgz = 0d;
        double gdcxd = 0d;
        double gdcsl = 0d;
        double gdclx = 0d;
        double rfh = 0d;
        double rzgfh = 0d;
        double yzgfh = 0d;
        double mhsycgl = 0d;
        double nssycgl = 0d;
        double qsycgl = 0d;
        double sbqycgl = 0d;
        double xsycgl = 0d;
        double dwkycgl = 0d;
        double plycgl = 0d;
        double xhycgl = 0d;
        double bzgl = 0d;
        double llgl = 0d;
        double ycgl = 0d;
        double swdl = 0d;
        double gwgwdl = 0d;
        double nwgwdl = 0d;
        double gwdl = 0d;
        double rfdl = 0d;
        double yfdl = 0d;
        double yfdlscada = 0d;
        double nfdl = 0d;
        double yswdl = 0d;
        double ygwgwdl = 0d;
        double ynwgwdl = 0d;
        double yxn1 = 0d;
        double yxn2 = 0d;
        double yxn3 = 0d;
        double yxn4 = 0d;
        double ygz1 = 0d;
        double ygz2 = 0d;
        double ywh1 = 0d;
        double ywh2 = 0d;
        double yxd1 = 0d;
        double yxd2 = 0d;
        double ysl1 = 0d;
        double ysl2 = 0d;
        double fnlyl = 0d;
        double mhsfdl = 0d;
        double mhsfs = 0d;
        double mhsllgl = 0d;
        double mhscxgl = 0d;
        double mhsagc = 0d;
        double nssfdl = 0d;
        double nssfs = 0d;
        double nssllgl = 0d;
        double nsscxgl = 0d;
        double nssagc = 0d;
        double qsfdl = 0d;
        double qsfs = 0d;
        double qsllgl = 0d;
        double qscxgl = 0d;
        double qsagc = 0d;
        double sbqfdl = 0d;
        double sbqfs = 0d;
        double sbqllgl = 0d;
        double sbqcxgl = 0d;
        double sbqxlcxgl = 0d;
        double sbqnwcxgl = 0d;
        double sbqagc = 0d;
        double sbqxlagc = 0d;
        double sbqnwagc = 0d;
        double xsfdl = 0d;
        double xsfs = 0d;
        double xsllgl = 0d;
        double xscxgl = 0d;
        double xsagc = 0d;
        double plfdl = 0d;
        double plfs = 0d;
        double plllgl = 0d;
        double plcxgl = 0d;
        double plagc = 0d;
        double dwkfdl = 0d;
        double dwkfs = 0d;
        double dwkllgl = 0d;
        double dwkcxgl = 0d;
        double dwkagc = 0d;
        double xhfdl = 0d;
        double xhfs = 0d;
        double xhllgl = 0d;
        double xhcxgl = 0d;
        double xhagc = 0d;
        double pjfs = 0d;
        double gfsjgl = 0d;
        Date beginDate = calendar.getTime();
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        Date ycDate = calendar.getTime();
        Calendar c = Calendar.getInstance();
        Date endDate = c.getTime();
        int day = c.get(Calendar.DAY_OF_MONTH);

        try {
            aqts = edosUtil.getRealData(Contant.AQTS).getPointValueInDouble();
            jpeyht = edosUtil.getRealData(Contant.JPEYHT).getPointValueInDouble();
            jpeyhl = edosUtil.getRealData(Contant.JPEYHL).getPointValueInDouble();
            jyys = edosUtil.getRealData(Contant.JYYS).getPointValueInDouble();
            jybm = edosUtil.getRealData(Contant.JYBM).getPointValueInDouble();
            fdcbw = edosUtil.getRealData(Contant.FDCBW).getPointValueInDouble();
            fdcdj = edosUtil.getRealData(Contant.FDCDJ).getPointValueInDouble();
            fdcjx = edosUtil.getRealData(Contant.FDCJX).getPointValueInDouble();
            fdcgz = edosUtil.getRealData(Contant.FDCGZ).getPointValueInDouble();
            fdcxd = edosUtil.getRealData(Contant.FDCXD).getPointValueInDouble();
            fdclx = edosUtil.getRealData(Contant.FDCLX).getPointValueInDouble();
            gdcbw = edosUtil.getRealData(Contant.GDCBW).getPointValueInDouble();
            gdcdj = edosUtil.getRealData(Contant.GDCDJ).getPointValueInDouble();
            gdcjx = edosUtil.getRealData(Contant.GDCJX).getPointValueInDouble();
            gdcgz = edosUtil.getRealData(Contant.GDCGZ).getPointValueInDouble();
            gdcxd = edosUtil.getRealData(Contant.GDCXD).getPointValueInDouble();
            gdclx = edosUtil.getRealData(Contant.GDCLX).getPointValueInDouble();
            rfh = edosUtil.getRealData(Contant.RFH).getPointValueInDouble();
            rzgfh = edosUtil.getHistStat(Contant.RFH, beginDate.getTime() / 1000, endDate.getTime() / 1000, 1l, (endDate.getTime() - beginDate.getTime()) / 1000, 0).get(0).getPointValueInDouble();
            List<PointData> yfhlist = edosUtil.getHistoryDatasSnap(Contant.RFH, ycDate.getTime() / 1000, endDate.getTime() / 1000, (long) day, (endDate.getTime() - ycDate.getTime()) / 1000);
            yzgfh = Collections.max(yfhlist.stream().map(y -> y.getPointValueInDouble()).collect(Collectors.toList()));
            mhsycgl = edosUtil.getRealData(Contant.MHSYCGL).getPointValueInDouble();
            nssycgl = edosUtil.getRealData(Contant.NSSYCGL).getPointValueInDouble();
            qsycgl = edosUtil.getRealData(Contant.QSYCGL).getPointValueInDouble();
            sbqycgl = edosUtil.getRealData(Contant.SBQYCGL).getPointValueInDouble();
            xsycgl = edosUtil.getRealData(Contant.XSYCGL).getPointValueInDouble();
            dwkycgl = edosUtil.getRealData(Contant.DKWYCGL).getPointValueInDouble();
            plycgl = edosUtil.getRealData(Contant.PLYCGL).getPointValueInDouble();
            xhycgl = edosUtil.getRealData(Contant.XHYCGL).getPointValueInDouble();
            ycgl = StringUtils.round(mhsycgl + nssycgl + qsycgl + sbqycgl + xsycgl + dwkycgl + plycgl + xhycgl, 2);
            gfsjgl = edosUtil.getRealData(Contant.GFSJGL).getPointValueInDouble();
            bzgl = edosUtil.getRealData(Contant.BZGL).getPointValueInDouble() / 1000 + gfsjgl;
            llgl = edosUtil.getRealData(Contant.LLGL).getPointValueInDouble() / 1000 + gfsjgl;
            swdl = edosUtil.getRealData(Contant.SWDL).getPointValueInDouble();

            gwgwdl = edosUtil.getRealData(Contant.GWGWDL).getPointValueInDouble();
            nwgwdl = edosUtil.getRealData(Contant.NWGWDL).getPointValueInDouble();
            gwdl = StringUtils.round(gwgwdl + nwgwdl, 2);

            rfdl = edosUtil.getRealData(Contant.RFDL).getPointValueInDouble();
            yfdl = edosUtil.getRealData(Contant.YFDL).getPointValueInDouble();
            nfdl = edosUtil.getRealData(Contant.NFDL).getPointValueInDouble();

            ygwgwdl = edosUtil.getRealData(Contant.YGWGWDL).getPointValueInDouble();
            ynwgwdl = edosUtil.getRealData(Contant.YNWGWDL).getPointValueInDouble();
            yswdl = edosUtil.getRealData(Contant.YSWDL).getPointValueInDouble();

            yxn1 = edosUtil.getRealData(Contant.YXN1).getPointValueInDouble();
            yxn2 = edosUtil.getRealData(Contant.YXN2).getPointValueInDouble();
            yxn3 = edosUtil.getRealData(Contant.YXN3).getPointValueInDouble();
            yxn4 = edosUtil.getRealData(Contant.YXN4).getPointValueInDouble();

            ygz1 = edosUtil.getRealData(Contant.YGZ1).getPointValueInDouble();
            ygz2 = edosUtil.getRealData(Contant.YGZ2).getPointValueInDouble();

            ywh1 = edosUtil.getRealData(Contant.YWH1).getPointValueInDouble();
            ywh2 = edosUtil.getRealData(Contant.YWH2).getPointValueInDouble();

            yxd1 = edosUtil.getRealData(Contant.YXD1).getPointValueInDouble();
            yxd2 = edosUtil.getRealData(Contant.YXD2).getPointValueInDouble();

            ysl1 = edosUtil.getRealData(Contant.YSL1).getPointValueInDouble();
            ysl2 = edosUtil.getRealData(Contant.YSL2).getPointValueInDouble();

            yfdlscada = edosUtil.getRealData(Contant.SYFDL).getPointValueInDouble();
            fnlyl = yfdlscada * 1000 / (yfdl + yxn1 + yxn2 + yxn3 + yxn4 + ygz1 + ygz2 + ywh1 + ywh2 + yxd1 + yxd2 + ysl1 + ysl2) * 100;

            mhsfdl = edosUtil.getRealData(Contant.MHSFDL).getPointValueInDouble();
            mhsfs = edosUtil.getRealData(Contant.MHSFS).getPointValueInDouble();
            mhsllgl = edosUtil.getRealData(Contant.MHSLLGL).getPointValueInDouble()/1000;
            mhscxgl = edosUtil.getRealData(Contant.MHSCXGL).getPointValueInDouble();
            mhsagc = edosUtil.getRealData(Contant.MHSAGC).getPointValueInDouble();

            nssfdl = edosUtil.getRealData(Contant.NSSFDL).getPointValueInDouble();
            nssfs = edosUtil.getRealData(Contant.NSSFS).getPointValueInDouble();
            nssllgl = edosUtil.getRealData(Contant.NSSLLGL).getPointValueInDouble()/1000;
            nsscxgl = edosUtil.getRealData(Contant.NSSCXGL).getPointValueInDouble();
            nssagc = edosUtil.getRealData(Contant.NSSAGC).getPointValueInDouble();

            qsfdl = edosUtil.getRealData(Contant.QSFDL).getPointValueInDouble();
            qsfs = edosUtil.getRealData(Contant.QSFS).getPointValueInDouble();
            qsllgl = edosUtil.getRealData(Contant.QSLLGL).getPointValueInDouble()/1000;
            qscxgl = edosUtil.getRealData(Contant.QSCXGL).getPointValueInDouble();
            qsagc = edosUtil.getRealData(Contant.QSAGC).getPointValueInDouble();

            sbqfdl = edosUtil.getRealData(Contant.SBQFDL).getPointValueInDouble();
            sbqfs = edosUtil.getRealData(Contant.SBQFS).getPointValueInDouble();
            sbqllgl = edosUtil.getRealData(Contant.SBQLLGL).getPointValueInDouble()/1000;
            sbqxlcxgl = edosUtil.getRealData(Contant.SBQXLCXGL).getPointValueInDouble() / 1000;
            sbqnwcxgl = edosUtil.getRealData(Contant.SBQNWCXGL).getPointValueInDouble();
            sbqcxgl = sbqxlcxgl + sbqnwcxgl;
            sbqxlagc = edosUtil.getRealData(Contant.SBQXLAGC).getPointValueInDouble();
            sbqnwagc = edosUtil.getRealData(Contant.SBQNWAGC).getPointValueInDouble();
            sbqagc = sbqxlagc + sbqnwagc;
            xsfdl = edosUtil.getRealData(Contant.XSFDL).getPointValueInDouble();
            xsfs = edosUtil.getRealData(Contant.XSFS).getPointValueInDouble();
            xsllgl = edosUtil.getRealData(Contant.XSLLGL).getPointValueInDouble()/1000;
            xscxgl = edosUtil.getRealData(Contant.XSCXGL).getPointValueInDouble();
            xsagc = edosUtil.getRealData(Contant.XSAGC).getPointValueInDouble();

            plfdl = edosUtil.getRealData(Contant.PLFDL).getPointValueInDouble();
            plfs = edosUtil.getRealData(Contant.PLFS).getPointValueInDouble();
            plllgl = edosUtil.getRealData(Contant.PLLLGL).getPointValueInDouble();
            plcxgl = edosUtil.getRealData(Contant.PLCXGL).getPointValueInDouble();
            plagc = edosUtil.getRealData(Contant.PLAGC).getPointValueInDouble();

            dwkfdl = edosUtil.getRealData(Contant.DWKFDL).getPointValueInDouble();
            dwkfs = edosUtil.getRealData(Contant.DWKFS).getPointValueInDouble();
            dwkllgl = edosUtil.getRealData(Contant.DKWLLGL).getPointValueInDouble();
            dwkcxgl = edosUtil.getRealData(Contant.DWKCXGL).getPointValueInDouble() / 100;
            dwkagc = edosUtil.getRealData(Contant.DWKAGC).getPointValueInDouble();

            xhfdl = edosUtil.getRealData(Contant.XHFDL).getPointValueInDouble();
            xhfs = edosUtil.getRealData(Contant.XHFS).getPointValueInDouble();
            xhllgl = edosUtil.getRealData(Contant.XHLLGL).getPointValueInDouble();
            xhcxgl = edosUtil.getRealData(Contant.XHCXGL).getPointValueInDouble();
            xhagc = edosUtil.getRealData(Contant.XHAGC).getPointValueInDouble();

            pjfs = edosUtil.getRealData(Contant.PJFS).getPointValueInDouble();
        } catch (Exception e) {
            e.printStackTrace();
        }
        company.setAqts(aqts);//安全天数
        company.setJpeyht(jpeyht);//减排二氧化碳
        company.setJpeyhl(jpeyhl);//减排二氧化硫
        company.setJyys(jyys);//节约用水
        company.setJybm(jybm);//节约标煤
        company.setFdcbw(fdcbw);//风电场并网
        company.setFdcdj(fdcdj);//风电场待机
        company.setFdcjx(fdcjx);//风电场检修
        company.setFdcgz(fdcgz);//风电场故障
        company.setFdcxd(fdcxd);//风电场限电
        company.setFdclx(fdclx);//风电场离线
        company.setFdcsl(fdcsl);//风电场受累
        company.setGdcbw(gdcbw);
        company.setGdcdj(gdcdj);
        company.setGdcjx(gdcjx);
        company.setGdcgz(gdcgz);
        company.setGdcxd(gdcxd);
        company.setGdclx(gdclx);
        company.setGdcsl(gdcsl);
        company.setFdcjr(fdcbw + fdcdj + fdcgz + fdcjx + fdclx + fdcxd + fdcsl);
        company.setGdcjr(gdcbw + gdcdj + gdcgz + gdcjx + gdclx + gdcxd + gdcsl);

        company.setDqfh(rfh);
        company.setRzgfh(rzgfh);
        company.setYzgfh(yzgfh);
        company.setYcgl(ycgl);
        company.setBzgl(bzgl);
        company.setLlgl(llgl);
        company.setSwdl(swdl);
        company.setGwdl(gwdl);
        String mmTemp = queryMMCurrentMonth();
        String[] mmArr = mmTemp.split("_");
        company.setMtbf(Double.parseDouble(mmArr[0]));
        company.setMttr(Double.parseDouble(mmArr[1]));

        double yjhfdl = getYjhfdl();
        double njhfdl = getNjhfdl();
        if (yjhfdl != 0) {
            company.setYwcl(StringUtils.round(yfdl / yjhfdl * 100, 2));
        }
        if (njhfdl != 0) {
            company.setNwcl(StringUtils.round(nfdl / njhfdl * 100, 2));
        }

        company.setRwcl(StringUtils.round(rfdl / 600 * 100, 2));
        if (yfdl != 0) {
            company.setZhcydl(StringUtils.round((yfdl + ygwgwdl + ynwgwdl - yswdl) / yfdl * 100, 2));
        }
        double sbklyl = getSbklyl();
        company.setSbklyl(sbklyl);
        company.setFnlyl(fnlyl);
        company.setMhsfdl(mhsfdl);
        company.setMhsfs(mhsfs);
        company.setMhsllgl(mhsllgl);
        company.setMhscxgl(mhscxgl);
        company.setMhsagc(mhsagc);
        company.setNssfdl(nssfdl);
        company.setNssfs(nssfs);
        company.setNssllgl(nssllgl);
        company.setNsscxgl(nsscxgl);
        company.setNssagc(nssagc);
        company.setQsfdl(qsfdl);
        company.setQsfs(qsfs);
        company.setQsllgl(qsllgl);
        company.setQscxgl(qscxgl);
        company.setQsagc(qsagc);
        company.setSbqfdl(sbqfdl);
        company.setSbqfs(sbqfs);
        company.setSbqllgl(sbqllgl);
        company.setSbqcxgl(sbqcxgl);
        company.setSbqagc(sbqagc);
        company.setXsfdl(xsfdl);
        company.setXsfs(xsfs);
        company.setXsllgl(xsllgl);
        company.setXscxgl(xscxgl);
        company.setXsagc(xsagc);
        company.setPlfdl(plfdl);
        company.setPlfs(plfs);
        company.setPlllgl(plllgl);
        company.setPlcxgl(plcxgl);
        company.setPlagc(plagc);
        company.setDwkfdl(dwkfdl);
        company.setDwkfs(dwkfs);
        company.setDwkllgl(dwkllgl);
        company.setDwkcxgl(dwkcxgl);
        company.setDwkagc(dwkagc);
        company.setXhfdl(xhfdl);
        company.setXhfs(xhfs);
        company.setXhllgl(xhllgl);
        company.setXhcxgl(xhcxgl);
        company.setXhagc(xhagc);
        company.setFl(ObjUtil.getFlByFs(pjfs));
        redisService.setObject(company);

    }




    private double getSbklyl() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM");

        Calendar cal = Calendar.getInstance();

        String rq = sdf.format(cal.getTime());

        int day = cal.get(Calendar.DAY_OF_MONTH);

        // 风机数
        List<Windturbine> wtls = CacheContext.wtls;
        int fjnum = wtls.size();
        DataVo vo = queryStopDataCurrentMonth(rq);
        double gzsj = vo.getDvalue1();

        return (day * 24 * fjnum - gzsj) / (day * 24 * fjnum)*100;

    }

    private double getNjhfdl() {
        Calendar cal = Calendar.getInstance();
        int year = cal.get(Calendar.YEAR);
        StringBuilder sb = new StringBuilder();
        sb.append("select sum(generatingcapacity) njhfdl from projectplan where year='");
        sb.append(String.valueOf(year)).append("'");
        return jdbcTemplate.query(String.valueOf(sb), new RowMapper<Double>() {
            @Override
            public Double mapRow(ResultSet rs, int i) throws SQLException {
                return rs.getDouble("njhfdl");
            }
        }).get(0);
    }

    private double getYjhfdl() {
        Calendar cal = Calendar.getInstance();
        int month = cal.get(Calendar.MONTH) + 1;
        int year = cal.get(Calendar.YEAR);
        //String mTemp = month<10?"0"+month:String.valueOf(month);
        StringBuilder sb = new StringBuilder();
        sb.append("select sum(generatingcapacity) yjhfdl from projectplan where year='");
        sb.append(String.valueOf(year)).append("' and month='");
        sb.append(month).append("'");
        return jdbcTemplate.query(String.valueOf(sb), new RowMapper<Double>() {
            @Override
            public Double mapRow(ResultSet rs, int i) throws SQLException {
                return rs.getDouble("yjhfdl");
            }
        }).get(0);

    }


    public String queryMMCurrentMonth() {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMM");

        Calendar cal = Calendar.getInstance();

        String rq = sdf.format(cal.getTime());

        int day = cal.get(Calendar.DAY_OF_MONTH);


        DataVo vo = queryStopDataCurrentMonth(rq);
        int count = vo.getIvalue1();
        double gzsj = vo.getDvalue1();

        // 风机数
        List<Windturbine> wtls = CacheContext.wtls;
        int fjnum = wtls.size();

        // 日历小时
        double dayhours = day * 24;

        double mtbf = count == 0 ? 0 : dayhours * fjnum / count;// 平均间隔时间
        double mttr = count == 0 ? 0 : gzsj / count;

        return mtbf + "_" + mttr;
    }

    private DataVo queryStopDataCurrentMonth(String rq) {
        StringBuilder sb = new StringBuilder();
        sb.append("select sum(cs) cs,sum(sssj) sj from MTTRMTBF where rq='");
        sb.append(rq).append("'");
        List<DataVo> list = jdbcTemplate.query(String.valueOf(sb),
                new RowMapper<DataVo>() {

                    @Override
                    public DataVo mapRow(ResultSet rs, int arg1)
                            throws SQLException {
                        DataVo vo = new DataVo();
                        vo.setIvalue1(rs.getInt("cs"));
                        vo.setDvalue1(rs.getDouble("sj"));
                        return vo;
                    }

                });
        if (list != null && list.size() > 0) {
            return list.get(0);
        }
        return null;
    }
}
