package cn.gyee.nxdp.websocket;

import cn.gyee.nxdp.entities.nxdp.CompanyTarget;
import cn.gyee.nxdp.util.redis.RedisService;
import com.alibaba.fastjson.JSONArray;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.concurrent.CopyOnWriteArraySet;

/**
 * /**
 *
 * @ClassName CompanyTask
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/9/2 10:17
 * @Version 1.0
 **/
@Component
@EnableScheduling
public class CompanyTask {
    private static Logger logger = LoggerFactory.getLogger(CompanyTask.class);
    @Autowired
    private RedisService redisService;


    @Scheduled(cron = "0/2 * * * * ?")   //每2s执行一次
    public void company() {
        //System.err.println("*********   定时任务执行   **************");
        CopyOnWriteArraySet<CompanyWebSocket> webSocketSet =
                CompanyWebSocket.getWebSocketSet();
        int i = 0;
        webSocketSet.forEach(c -> {
            try {
                c.sendMessage(fromRedisMessage());
            } catch (IOException e) {
                e.printStackTrace();
            }
        });

        //System.err.println("*********   定时任务完成   **************");
    }

    private String fromRedisMessage() {
        CompanyTarget model = new CompanyTarget();

        Field[] field = model.getClass().getDeclaredFields();
        try {
            for (int j = 0; j < field.length; j++) {
                String name = field[j].getName();
                if(redisService.hasKey(name)){
                    String value = redisService.get(name);
                    String type = field[j].getGenericType().toString();
                    name = name.substring(0, 1).toUpperCase() + name.substring(1);
                    // 获取属性的类型
                    if (type.equals("class java.lang.String")) { // 如果type是类类型，则前面包含"class "，后面跟类名
                        Method m = model.getClass().getMethod("set" + name, String.class);
                        if (value != null && value.length() != 0){
                            m.invoke(model, value);
                        }else {
                            m.invoke(model, "");
                        }

                    }
                    if (type.equals("class java.lang.Double")) {
                        Method m = model.getClass().getMethod("set" + name, Double.class);
                        if (value != null && value.length() != 0){
                            m.invoke(model, Double.parseDouble(value));
                        }else {
                            m.invoke(model, 0d);
                        }

                    }
                    if (type.equals("class java.lang.Integer")) {
                        Method m = model.getClass().getMethod("set" + name, Integer.class);
                        if (value != null && value.length() != 0){
                            m.invoke(model, Integer.parseInt(value));
                        }else {
                            m.invoke(model, 0);
                        }

                    }
                }

            }
        } catch (NoSuchMethodException e) {
            e.printStackTrace();
        } catch (SecurityException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (InvocationTargetException e) {
            e.printStackTrace();
        }
        return JSONArray.toJSON(model).toString();
    }

}
