package cn.gyee.nxdp.websocket;

import cn.gyee.nxdp.services.shbracelet.ShbraceletService;
import cn.gyee.nxdp.util.JsonUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.concurrent.CopyOnWriteArraySet;

/**
 * /**
 *
 * @ClassName ShbraceletTask
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/9/2 10:17
 * @Version 1.0
 **/
@Component
@EnableScheduling
public class ShbraceletTask {
    private static Logger logger = LoggerFactory.getLogger(ShbraceletTask.class);
    @Autowired
    private ShbraceletService shbraceletService;
    @Scheduled(cron = "0/5 * * * * ?")   //每2s执行一次
    public void company() {
        //System.err.println("*********   定时任务执行   **************");
        CopyOnWriteArraySet<ShbraceletWebSocket> webSocketSet =
                ShbraceletWebSocket.getWebSocketSet();
        int i = 0;
        webSocketSet.forEach(c -> {
            try {

                c.sendMessage(JsonUtils.toJson(shbraceletService.findShbraceletDataNew()));
            } catch (IOException e) {
                e.printStackTrace();
            } catch (Exception e) {
                e.printStackTrace();
            }
        });

        //System.err.println("*********   定时任务完成   **************");
    }



}
