package cn.gyee.nxdp.websocket;

import cn.gyee.nxdp.util.redis.RedisService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @ClassName WindturbineTask
 * @Description TODO
 * @Author 谢生杰
 * @Date 2020/9/2 10:17
 * @Version 1.0
 **/
@Component
@EnableScheduling
public class WindturbineTask {
    private static Logger logger = LoggerFactory.getLogger(WindturbineTask.class);
    @Autowired
    private RedisService redisService;

    @Scheduled(cron = "0/2 * * * * ?")   //每2s执行一次
    public void windturbines() {
        //System.err.println("*********   定时任务执行   **************");
        ConcurrentHashMap<String, WindturbineWebSocket> webSocketSet =
                WindturbineWebSocket.getWebSocketSet();
        int i = 0;
        webSocketSet.forEach((k, v) -> {
            try {
                if (webSocketSet.get(k).getSession().isOpen()) {
                    webSocketSet.get(k).sendMessage(redisService.get(k));
                }
            } catch (IOException e) {
                e.printStackTrace();
            }

        });

        //System.err.println("*********   定时任务完成   **************");
    }


}
